##### wv׋246񃍃WXeBbNÁ@R code #####

### Low Infant Birth Weightf[^̏ ###

library(MASS)
data(birthwt)
head(birthwt, n=2)

birthwt <- birthwt[, -10]		# bwt: ȍd
birthwt$race <- factor(birthwt$race, label=c("white", "black", "other"))	# q^ɕϊÃx1, 2, 3Awhite, black, otherɕύXB
birthwt$ptl[birthwt$ptl >= 1] <- "1+"		# ptl: 1ȏ̒l "1+" ƂB
birthwt$ftv[birthwt$ftv >= 1] <- "1+"		# ftv: 1ȏ̒l "1+" ƂB
head(birthwt, n=2)

attach(birthwt)	# birthwtɊ܂܂ϐAʂɈ悤ɂB


### logistic regression ###

fit <- glm(low ~ age + lwt + race + smoke + ptl + ht + ui + ftv, family=binomial, data=birthwt)
summary(fit)

## W̐M ##
confint(fit)

## IbY̐M ##
exp(confint(fit))

## Cxg̗\m ##
fit$fitted



### goodness of fit test for logistic regression ###

## Hosmer-Lemeshow ##
#install.packages("ResourceSelection")	# ̂ 
library(ResourceSelection)
hl <- hoslem.test(low, fit$fitted, g=10)

## ROCȐAUC ##
library(pROC)
tbl.roc <- roc(low, fit$fitted)
plot(tbl.roc, print.auc=TRUE, print.thres=TRUE)				# ROCȐ̕`
opt.sp <- tbl.roc$sp[which.max(tbl.roc$se+tbl.roc$sp)]		# œKȓٓx
opt.se <- tbl.roc$se[which.max(tbl.roc$se+tbl.roc$sp)]		# œKȊx
abline((opt.sp+opt.se), -1)		# œKȃJbg|Cgʂ45x



## ϐI ##
library(MASS)
fit.aic1 <- stepAIC(fit, direction="backward")			# backward elimination #
summary(fit.aic1)

fit0 <- glm(low ~ 1, family=binomial, data=birthwt)	# forward selection #
fit.aic2 <- stepAIC(fit0, direction="forward", scope=list(upper=fit, lower=fit0))
summary(fit.aic2)

fit.aic3 <- stepAIC(fit0, direction="both", scope=list(upper=fit, lower=fit0))	# both #
summary(fit.aic3)



### Generalized Additive Model ###
#install.packages("mgcv")	# ̂ 
library(mgcv)
fit.gam <- gam(low ~ s(age) + s(lwt) + race + smoke + ptl + ht + ui, family=binomial, data=birthwt)
summary(fit.gam)

par(mfrow=c(1,2))
plot(fit.gam)


## additive model ##
fit.gam2 <- gam(lwt ~ s(age), family=gaussian, data=birthwt)

summary(fit.gam2)

plot(age, lwt)

ord <- order(age)

lines(age[ord], fit.gam2$fitted[ord], col="red", lwd=2)

fit.lm <- lm(lwt ~ age, data=birthwt)

summary(fit.lm)

lines(age[ord], fit.lm$fitted[ord], col="green", lwd=2)
